import woob.browser.elements as OLD

# can't import *, __all__ is incomplete...
for attr in dir(OLD):
    globals()[attr] = getattr(OLD, attr)

try:
    __all__ = OLD.__all__
except AttributeError:
    pass


from woob.browser.filters.json import Dict


class ItemElementRerootMixin:
    """
    Mixin used to reroot an ItemElement by defining a reroot_xpath.
    """

    reroot_xpath = None

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

        if self.reroot_xpath:
            if hasattr(self.el, 'xpath'):
                self.el = self.el.xpath(self.reroot_xpath)
            elif isinstance(self.el, (dict, list)):
                self.el = Dict.select(self.reroot_xpath.split('/'), self)



del OLD
